%{
static char	*ibegp, *iendp ;	/* pointer to input buffer */
static char	*cendp ;	/* pointer to output buffer */
static int	complete ;	/* the word was fixed */
static int	failcount ;
#define PUTONE(str)	if (failcount) {return -1;} else putone(str)
#define YOUON(str)	if (failcount) {return -1;} else youon(str)
%}

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]
V	[aueoAUEO]
%%
{a}	{ PUTONE("$@$"(J") ; }
{i}	{ PUTONE("$@$$(J") ; }
{u}	{ PUTONE("$@$&(J") ; }
{e}	{ PUTONE("$@$((J") ; }
{o}	{ PUTONE("$@$*(J") ; }
{k}{a}	{ PUTONE("$@$+(J") ; }
{k}{i}	{ PUTONE("$@$-(J") ; }
{k}{u}	{ PUTONE("$@$/(J") ; }
{k}{e}	{ PUTONE("$@$1(J") ; }
{k}{o}	{ PUTONE("$@$3(J") ; }
{k}{y}{V}	{ YOUON("$@$-(J") ; }
{g}{a}	{ PUTONE("$@$,(J") ; }
{g}{i}	{ PUTONE("$@$.(J") ; }
{g}{u}	{ PUTONE("$@$0(J") ; }
{g}{e}	{ PUTONE("$@$2(J") ; }
{g}{o}	{ PUTONE("$@$4(J") ; }
{g}{y}{V}	{ YOUON("$@$.(J") ; }
{s}{a}	{ PUTONE("$@$5(J") ; }
{s}{h}?{i}	{ PUTONE("$@$7(J") ; }
{s}{u}	{ PUTONE("$@$9(J") ; }
{s}{e}	{ PUTONE("$@$;(J") ; }
{s}{o}	{ PUTONE("$@$=(J") ; }
{s}({h}|{y}){V}	{ YOUON("$@$7(J") ; }
{z}{a}	{ PUTONE("$@$6(J") ; }
({z}|{j}){i}	{ PUTONE("$@$8(J") ; }
{z}{u}	{ PUTONE("$@$:(J") ; }
{z}{e}	{ PUTONE("$@$<(J") ; }
{z}{o}	{ PUTONE("$@$>(J") ; }
({z}{y}|{j}){V}	{ YOUON("$@$8(J") ; }
{t}{a}	{ PUTONE("$@$?(J") ; }
({t}|{c}{h}){i}	{ PUTONE("$@$A(J") ; }
{t}{s}?{u}	{ PUTONE("$@$D(J") ; }
{t}{e}	{ PUTONE("$@$F(J") ; }
{t}{o}	{ PUTONE("$@$H(J") ; }
({t}{y}|{c}{h}){V}	{ YOUON("$@$A(J") ; }
{t}/{c}{h}	{ PUTONE("$@$C(J") ; }
{d}{a}	{ PUTONE("$@$@(J") ; }
{d}{i}	{ PUTONE("$@$B(J") ; }
{d}{u}	{ PUTONE("$@$E(J") ; }
{d}{e}	{ PUTONE("$@$G(J") ; }
{d}{o}	{ PUTONE("$@$I(J") ; }
{d}{y}{V}	{ YOUON("$@$B(J") ; }
{d}{h}{i}	{ PUTONE("$@$G$#(J") ; }
{n}{a}	{ PUTONE("$@$J(J") ; }
{n}{i}	{ PUTONE("$@$K(J") ; }
{n}{u}	{ PUTONE("$@$L(J") ; }
{n}{e}	{ PUTONE("$@$M(J") ; }
{n}{o}	{ PUTONE("$@$N(J") ; }
{n}{y}{V}	{ YOUON("$@$K(J") ; }
{n}\'?	{ PUTONE("$@$s(J") ; }
{n}/\$	{ putone("n") ;
	  /* to avoid that "...n" is converted to "...$@$s(J" in typing a word */ }
{h}{a}	{ PUTONE("$@$O(J") ; }
{h}{i}	{ PUTONE("$@$R(J") ; }
({h}|{f}){u}	{ PUTONE("$@$U(J") ; }
{h}{e}	{ PUTONE("$@$X(J") ; }
{h}{o}	{ PUTONE("$@$[(J") ; }
{h}{y}{V}	{ YOUON("$@$R(J") ; }
{f}{a}	{ PUTONE("$@$U$!(J") ; }
{f}{i}	{ PUTONE("$@$U$#(J") ; }
{f}{e}	{ PUTONE("$@$U$'(J") ; }
{f}{o}	{ PUTONE("$@$U$)(J") ; }
{b}{a}	{ PUTONE("$@$P(J") ; }
{b}{i}	{ PUTONE("$@$S(J") ; }
{b}{u}	{ PUTONE("$@$V(J") ; }
{b}{e}	{ PUTONE("$@$Y(J") ; }
{b}{o}	{ PUTONE("$@$\(J") ; }
{b}{y}{V}	{ YOUON("$@$S(J") ; }
{p}{a}	{ PUTONE("$@$Q(J") ; }
{p}{i}	{ PUTONE("$@$T(J") ; }
{p}{u}	{ PUTONE("$@$W(J") ; }
{p}{e}	{ PUTONE("$@$Z(J") ; }
{p}{o}	{ PUTONE("$@$](J") ; }
{p}{y}{V}	{ YOUON("$@$T(J") ; }
{m}{a}	{ PUTONE("$@$^(J") ; }
{m}{i}	{ PUTONE("$@$_(J") ; }
{m}{u}	{ PUTONE("$@$`(J") ; }
{m}{e}	{ PUTONE("$@$a(J") ; }
{m}{o}	{ PUTONE("$@$b(J") ; }
{m}{y}{V}	{ YOUON("$@$_(J") ; }
{y}{a}	{ PUTONE("$@$d(J") ; }
{y}{u}	{ PUTONE("$@$f(J") ; }
{y}{o}	{ PUTONE("$@$h(J") ; }
{r}{a}	{ PUTONE("$@$i(J") ; }
{r}{i}	{ PUTONE("$@$j(J") ; }
{r}{u}	{ PUTONE("$@$k(J") ; }
{r}{e}	{ PUTONE("$@$l(J") ; }
{r}{o}	{ PUTONE("$@$m(J") ; }
{r}{y}{V}	{ YOUON("$@$j(J") ; }
{w}{a}	{ PUTONE("$@$o(J") ; }
{w}{i}	{ PUTONE("$@$&$#(J") ; }
{w}{e}	{ PUTONE("$@$&$'(J") ; }
{w}{o}	{ PUTONE("$@$r(J") ; }
{m}/({b}|{m}|{p})	{ PUTONE("$@$s(J") ; }
{x}{a}	{ PUTONE("$@$!(J") ; }
{x}{i}	{ PUTONE("$@$#(J") ; }
{x}{u}	{ PUTONE("$@$%(J") ; }
{x}{e}	{ PUTONE("$@$'(J") ; }
{x}{o}	{ PUTONE("$@$)(J") ; }
{x}{y}{V}	{ YOUON("") ; }
{x}{t}{s}?{u}	{ PUTONE("$@$C(J") ; }
({k}|{g}|{s}|{z}|{j}|{t}|{c}|{d}|{h}|{f}|{b}|{p}|{y}|{r}|{w})({k}|{g}|{s}|{z}|{j}|{t}|{c}|{d}|{h}|{f}|{b}|{p}|{y}|{r}|{w}) {
	if ( yytext[0] == yytext[1] ) {
		yyless(1) ;
		PUTONE("$@$C(J") ;
	} else {
		REJECT ;
	}
}
{x}{w}{a}	{ PUTONE("$@$n(J") ; }
\-	{ PUTONE("$@!<(J") ; }
\$	;
.	{
	if ( complete )
		return	-1 ;
	failcount++ ;
	putone(yytext) ;
}
%%
#include "defs.h"

static int	katakana ;

convert_word(ib, ie, op, c)
	char	*ib ;
	char	*ie ;
	char	*op ;
	int	c ;
{
	if ( *ib & 0x80 )	/* all the characters in the word should
				   be scanned */
		return	-1 ;
	else if ( isupper(*ib) ) {
		if ( ie - ib > 1 && isupper(*(ib + 1)) )
			return	-1 ;
		katakana = 1 ;
	} else
		katakana = 0 ;

	ibegp = ib ;
	iendp = ie ;
	cendp = op ;
	complete = c ;
	failcount = 0 ;
	yysptr = yysbuf ;
	return	yylex() ;
}

convert_string(ip, op)
	char	*ip, *op ;
{
	register char	*p ;

	for ( p = ip ; *p ; ) {
		while ( iswordch(*p) )
			p++ ;
		if ( p > ip ) {
			if ( convert_word(ip, p, op, 1) == 0 )
				op += strlen(op) ;
			else {
				strncpy(op, ip, p - ip) ;
				op += p - ip ;
			}
		} else {
			*op++ = *p++ ;
		}
		ip = p ;
	}
	*op = 0 ;
}

static
youon(base)
	char	*base ;
{
	char	boin = yytext[yyleng - 1] ;
	char	*last ;
	char	tmp[10] ;

	switch ( boin ) {
	case  'a' :  case  'A' :
		last = "$@$c(J" ;
		break ;
	case  'u' :  case  'U' :
		last = "$@$e(J" ;
		break ;
	case  'e' :  case  'E' :
		last = "$@$'(J" ;
		break ;
	case  'o' :  case  'O' :
		last = "$@$g(J" ;
		break ;
	}
	sprintf(tmp, "%s%s", base, last) ;
	putone(tmp) ;
}

static
putone(s)
	register unsigned char	*s ;
{
	while ( *s ) {
		if ( *s & 0x80 ) {
			if ( katakana && *s == 0xa4 )
				*cendp++ = 0xa5, ++s ;
			else
				*cendp++ = *s++ ;
		}
		*cendp++ = *s++ ;
	}
	*cendp = 0 ;
}

#undef input
static
input()
{
	char	ch ;

	if ( yysptr > yysbuf )
		yytchar = *--yysptr ;
	else {
		if ( ibegp > iendp )
			yytchar = 0 ;
		else if ( ibegp == iendp )
			yytchar = complete ? 0 : '$' ;
		else
			yytchar = *ibegp ;
		ibegp++ ;
	}

	return	yytchar ;
}
