#ifndef lint
static char	rcsid[] = "$Header: wclear.c,v 2.1 87/10/18 19:05:29 tachi Exp $" ;
#endif

#include "win.h"

w_clear(w)
	Win	*w ;
{
	register int	i, j ;
	register Wchar	*bp ;
	register Wline	*p ;

	if ( w->w_flags & W_CLEAR )
		return ;

	for ( p = w->w_l, i = w->w_lines ; i > 0 ; i--, p++ ) {
		bp = p->l_buf ;
		for ( j = w->w_cols ; j > 0 ; j-- ) {
			*bp++ = make_wchar(' ', 0) ;
		}
		p->l_modflag = 1 ;
	}
	w->w_pos.x = w->w_pos.y = 0 ;
	if ( w->w_flags & (W_FULL | W_BOTTOM | W_RIGHT) )
		w->w_flags |= W_CLEAR ;
}

w_clrtoeol(w)
	Win	*w ;
{
	register int	i ;
	register Wchar	*bp ;
	Wline	*l ;

	l = w->w_l + w->w_pos.y ;
	bp = l->l_buf + w->w_pos.x ;
	for ( i = w->w_cols - w->w_pos.x ; i > 0 ; i-- )
		*bp++ = make_wchar(' ', 0) ;
	l->l_modflag = 1 ;
}

w_output_clear(w, y, maxy, minx)
	Win	*w ;
	int	y, maxy, minx ;
{
	if ( (w->w_flags & W_FULL) && str_cl )
		tputs(str_cl, num_li, w_outc) ;
	else if ( (w->w_flags & W_BOTTOM) && str_cd ) {
		w_move_cursor(y, minx) ;
		tputs(str_cd, maxy - y, w_outc) ;
	}
	else if ( (w->w_flags & W_RIGHT) && str_ce ) {
		w_move_cursor(y, minx) ;
		for (;;) {
			tputs(str_ce, 0, w_outc) ;
			if ( ++y >= maxy )
				break ;
			tputs(str_nl, 0, w_outc) ;
		}
		_screen->w_pos.y = maxy - 1 ;
	}
	else
		return	1 ;

	return	0 ;
}

w_clear_screen()
{
	w_clear(_screen) ;
	w_redraw_screen() ;
	_screen->w_flags &= ~W_CLEAR ;	/* kludge */
}
